<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<!--

  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  
  Copyright 2008 by Sun Microsystems, Inc.
 
  OpenOffice.org - a multi-platform office productivity suite
 
  $RCSfile: package.html,v $
 
  $Revision: 1.3 $
 
  This file is part of OpenOffice.org.
 
  OpenOffice.org is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License version 3
  only, as published by the Free Software Foundation.
 
  OpenOffice.org is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License version 3 for more details
  (a copy is included in the LICENSE file that accompanied this code).
 
  You should have received a copy of the GNU Lesser General Public License
  version 3 along with OpenOffice.org.  If not, see
  <http://www.openoffice.org/license.html>
  for a copy of the LGPLv3 License.
 
-->
<html>
<head>
<title>org.openoffice.xmerge.merger package</title>
</head>

<body bgcolor="white">
<p>The <code>DiffAlgorithm</code> and <code>MergeAlgorithm</code>
are used to provide the merge capabilities of this project.</p>

<p>Merge is useful when an <code>OfficeDocument</code>
is converted to a &quot;Device&quot; <code>Document</code> format,
and the &quot;Device&quot; <code>Document</code> version is modified.
Those changes can be merged back into the original
<code>OfficeDocument</code> with the merger.  The merger is capable
of doing this even if the &quot;Device&quot; format is lossy in
comparison to the <code>OfficeDocument</code> format.</p>

<p>The <code>DiffAlgorithm</code> generates a list of
<code>Difference</code> objects that represent the
differences between two <code>OfficeDocument</code> objects.
It is assumed that one is the original <code>OfficeDocument</code>
object and the other is a &quot;lossy&quot; version of the same
<code>Document</code> with edits to be merged.  Typically the
&quot;lossy&quot; version is created by converting a &quot;Device&quot
<code>Document</code> back into an <code>OfficeDocument</code>.

<p>The <code>MergeAlgorithm</code> takes the <code>Difference</code>
objects as input, and creates a merged <code>OfficeDocument</code>.
A merged <code>OfficeDocument</code> has the following features:</p>

<p><ul>
<li>Tags in the <code>OfficeDocument</code> that are not
    supported in the device format are not altered or removed.
<li>Changes made to the device format are merged back into
    the <code>OfficeDocument</code> in the location determined by
    the <code>DiffAlgorithm</code>.
</ul></p>

<p>Each converter provides an implementation of the
{@link org.openoffice.xmerge.ConverterCapabilities
ConverterCapabilities} which specifies which 
<code>OfficeDocument</code> tags are supported for the
device format.</p>

</body>
</html>
